 #############################################################################
# Copyright (c) 2002 Pelle Johansson.                                         #
# All rights reserved.                                                        #
#                                                                             #
# This file is part of the moftpd package. Use and distribution of            #
# this software is governed by the terms in the file LICENCE, which           #
# should have come with this package.                                         #
 #############################################################################

# $moftpd: acinclude.m4,v 1.8 2003/08/28 23:40:35 morth Exp $
# $Id$

# Whether --dump-pch is supported
AC_DEFUN([AC_PRECOMPILE],
[AC_ARG_ENABLE(precompile,
      AC_HELP_STRING([--disable-precompile],[Do not use precompiling]))
PRECOMP="touch $2"
if test "$enable_precompile" != no; then
  AC_CACHE_CHECK([whether ${CC} supports pch precompiled headers],
    ac_cv_precompile_CC,
    [ac_cv_precompile_CC=no
     ac_save_CC=$CC
     CC="$CC --dump-pch conftest.$ac_objext"
     AC_LANG_CONFTEST([])
     AC_COMPILE_IFELSE([],[ac_cv_precompile_CC=yes])
     CC=$ac_save_CC
     rm -rf conftest.$ac_objext])
  if test "$ac_cv_precompile_CC" != no; then
    PRECOMP="${CC} ${CFLAGS} \${DEFS} -x c --dump-pch $2 \${srcdir}/$1"
    CFLAGS="${CFLAGS} --load-pch \${topobjdir}/$2"
  fi
fi
AC_SUBST(PRECOMP)
])

AC_DEFUN([AC_NATIVE_CHARSET],
[AC_ARG_WITH(native_charset,
	AC_HELP_STRING([--with-native-charset=charset],
[Use specified charset if a string is not
UTF-8. Disable to only use UTF-8. Default is iso8859-15.]),
	[ac_native_charset=$withval], [ac_native_charset=iso8859-15])
if test "$ac_native_charset" = no; then
  ac_native_charset=None
fi
AC_CACHE_CHECK([what native charset to use],[ac_cv_native_charset],
	[ac_cv_native_charset=$ac_native_charset])
if test "$ac_cv_native_charset" != "None"; then
	AC_DEFINE(HAVE_NATIVE_CHARSET,1,[If we're to use a native charset])
	native_charset=$ac_cv_native_charset
else
	native_charset="none"
fi
AC_SUBST(native_charset)
])

AC_DEFUN([AC_CC_FLAG],
[AS_VAR_PUSHDEF([ac_cc_flag], [ac_cv_cc_flag_$1])
 AC_CACHE_CHECK([whether ${CC} accepts $1],
    ac_cc_flag,
    [ac_save_CFLAGS=$CFLAGS
     CFLAGS="$CFLAGS $1"
     AC_LANG_CONFTEST([])
     AC_COMPILE_IFELSE([],[AS_VAR_SET(ac_cc_flag, yes)],[
       AS_VAR_SET(ac_cc_flag, no)
       CFLAGS=$ac_save_CFLAGS
      ])
    ])
 AS_VAR_POPDEF([ac_cc_flag])
])
