/*****************************************************************************\
* Copyright (c) 2002 Pelle Johansson.                                         *
* All rights reserved.                                                        *
*                                                                             *
* This file is part of the moftpd package. Use and distribution of            *
* this software is governed by the terms in the file LICENCE, which           *
* should have come with this package.                                         *
\*****************************************************************************/

/* $moftpd: main.h,v 1.8.2.1 2003/09/16 11:12:28 morth Exp $ */
/* $Id$ */

#ifndef _MAIN_H
#define _MAIN_H

#include "system.h"

typedef void (*fdHandlerFun_t)(int fd, void *user, int urgent);

int parse_options(int argc, char ***argv);
void usage(void) __attribute__((__noreturn__));

int add_read_fd(int fd, fdHandlerFun_t handler, void *user);
int add_write_fd(int fd, fdHandlerFun_t handler, void *user);
void remove_read_fd(int fd);
void remove_write_fd(int fd);

int super_privs(int failIfChroot);
int drop_privs(void);
int set_uid(uid_t uid, int permanent);
int set_gid(gid_t id, int permanent);
int set_groups(int ngroups, const gid_t *groups);
void set_locale (const char *loc);

int same_addr(const struct sockaddr *a1, const struct sockaddr *a2,
      int checkPort);

#endif /*_MAIN_H*/
