/*****************************************************************************\
* Copyright (c) 2002-2003 Pelle Johansson.                                    *
* All rights reserved.                                                        *
*                                                                             *
* This file is part of the moftpd package. Use and distribution of            *
* this software is governed by the terms in the file LICENCE, which           *
* should have come with this package.                                         *
\*****************************************************************************/

/* $moftpd: system.h,v 1.15.2.2 2003/09/26 21:23:32 morth Exp $ */
/* $Id$ */

#ifndef _SYSTEM_H
#define _SYSTEM_H

#ifdef HAVE_CONFIG_H
#include "autoconf.h"
#endif

#define _GNU_SOURCE // Needed on linux
//#define _XOPEN_SOURCE // Needed for SunOS, others?
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <stdarg.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/signal.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/uio.h>
#ifdef HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
#endif

#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>

#include <pwd.h>
#include <grp.h>
#include <netdb.h>
#include <dirent.h>
#include <syslog.h>
#include <time.h>
#include <locale.h>
#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif
#include <limits.h>
#ifdef HAVE_CRYPT_H
#include <crypt.h>
#endif
#ifdef HAVE_SHADOW_H
#include <shadow.h>
#endif

#ifdef HAVE_LIBSSL
#include <openssl/ssl.h>
#include <openssl/err.h>
#endif

#include "compat.h"

#endif /*_SYSTEM_H*/
