/*****************************************************************************\
* Copyright (c) 2002 Pelle Johansson.                                         *
* All rights reserved.                                                        *
*                                                                             *
* This file is part of the moftpd package. Use and distribution of            *
* this software is governed by the terms in the file LICENCE, which           *
* should have come with this package.                                         *
\*****************************************************************************/

/* $moftpd: memory.h,v 1.1 2003/08/24 13:15:58 morth Exp $ */
/* $Id$ */

#ifndef _MEMORY_H
#define _MEMORY_H

#include "system.h"

enum
{
  pNextParent = 0, pNextChild, pParent, pChild, pNumLinkLinks,
  pNextTemp = 0, pNumTempLinks
};

struct memdata;
struct memhash;

typedef union memory
{
  union memory *link;
  struct memdata *data;
  struct memhash *hash;
} memory_t;

typedef struct memdata
{
  memory_t firstParent, firstChild;
  unsigned int isHashed:1, mark:1;
  struct memdata *next;
} memdata_t;

typedef struct memhash
{
  memdata_t **bucket;
  memdata_t *next;
} memhash_t;

void mem_init (void);

void *talloc(size_t sz);
void *trealloc(void *ptr, size_t sz);
void tfree_all(void);

char *tstring(const char *str);

void *palloc(size_t sz, void *parent);
void *prealloc(void *ptr, size_t sz);
void *pattach(void *child, void *parent);
void *padopt(void *child, void *oldparent, void *newparent);
void pfree(void *child, void *parent);

void *pchild(const void *parent, const void *prevChild);

void *proot(void);
char *pstring(const char *str, void *parent);

#endif /*_MEMORY_H*/
